<template>
  <div
    ref="btn"
    :is="tag"
    :class="btnClass"
    v-bind="$attrs"
    :style="style"
    @click="handleClick"
  >
    <span v-if="loading"> ...loading </span>
    <slot v-else></slot>
  </div>
</template>
<!--bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium-->
<script>
export default {
  name: 'appBtn',
  props: {
    icon: { type: Boolean, default: false },
    fab: { type: Boolean, default: false },
    link: { type: Boolean, default: false },
    fixed: { type: Boolean, default: false },
    loading: { type: Boolean, default: false },
    disabled: { type: Boolean, default: false },
    primary: { type: Boolean, default: false },
    mobile: { type: Boolean, default: false },
    width: { type: [String, Number], default: null },
    activeClass: {
      type: String,
      default:
        'bg-gray-900 text-white px-3 py-2 rounded-md text-sm font-medium',
    },
  },
  data: () => ({ active: false }),
  computed: {
    btnClass() {
      const link = this.link
        ? 'app-btn text-gray-300 hover:bg-gray-700 hover:text-white px-3 py-2 rounded-md text-sm font-medium'
        : '';
      const icon = this.icon
        ? 'app-btn inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-white hover:bg-gray-700 focus:outline-none focus:ring-2 focus:ring-inset focus:ring-white'
        : '';
      const mobile = this.mobile
        ? 'app-btn text-gray-300 hover:bg-gray-700 hover:text-white block px-3 py-2 rounded-md text-base font-medium'
        : '';
      const primary = this.primary
        ? 'w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-red-600 text-base font-medium text-white hover:bg-red-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-red-500 sm:ml-3 sm:w-auto sm:text-sm'
        : null;
      const _default =
        'mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:ml-3 sm:w-auto sm:text-sm';
      const fab = this.fab
        ? 'p-0 w-16 h-16 rounded-full hover:bg-red-700 active:shadow-lg mouse shadow transition ease-in duration-200 focus:outline-none'
        : null;
      return fab || primary || mobile || icon || link || _default;
    },
    tag() {
      return this.$attrs.to ? 'router-link' : 'button';
    },
    style() {
      const width = this.width ? { width: this.width + 'px' } : {};

      const fixed = this.fixed ? { position: 'fixed' } : {};
      return { ...width, ...fixed };
    },
  },
  methods: {
    handleClick() {
      if (!this.loading && !this.disabled) {
        this.$emit('click');
      }
    },
  },
};
</script>
<style>
.app-btn.router-link-active {
  --tw-bg-opacity: 1;
  background-color: rgba(17, 24, 39, var(--tw-bg-opacity));
}
</style>
